#ifndef _Profiler_h
#define _Profiler_h
#ifdef __cplusplus
extern "C" {
#endif
	void initCounters();
	void startCounter(int);

#ifdef __cplusplus
	void stopCounter(int, LARGE_INTEGER * = 0);
#endif
	void stopCounterC(int);
	void dumpCounters();

	int stateCount();

	void addBlitEntry(int w, int h, LARGE_INTEGER *);


	void profilerSourceAttribute(unsigned long);
	void profilerSourceDeattribute();
#ifdef __cplusplus
};
#endif

#define STATE_RUNTIME 0
#define STATE_RDCT 1
#define STATE_COLORSPACE 2
#define STATE_NET_RECV 3
#define STATE_PUTIMAGE_SLOW 4
#define STATE_H261_DECODE 5
#define STATE_TCL_WAIT 6
#define STATE_TCL_UPDATE 7
#define STATE_CREATE_DIBITMAP 8
#define STATE_BITBLT 9
#define STATE_RTP_LATE 10
#define STATE_PUTIMAGE_DDRAW 11
#define STATE_PUTIMAGE_SHARED 12
#define STATE_MONITOR_CHECK 13
#define STATE_DAMAGE 14

#define N_STATES 15

#endif
